const int pompe = 9;
const int DEL = 11;

const byte n = 20;
char message[n];

char onOff[n];
int temps, pourcentage, bpm, pression;

boolean nouveauMsg = false;

void setup() {
    Serial.begin(9600);
    pinMode(pompe, OUTPUT);
    pinMode(DEL, OUTPUT);
    digitalWrite(DEL, HIGH);
}

void loop() {
    recevoirValeurs();
    if (nouveauMsg == true) {
        separerMsg();
        nouveauMsg = false;
    }
    allumerPompe();
    Serial.println(onOff);
}


//Recoit le message envoyé par le cellulaire
void recevoirValeurs() {
    static boolean recoitEnProgres = false;
    static byte i = 0;
    char charDebut = '<';
    char charFin = '>';
    char recu;

    while (Serial.available() > 0 && nouveauMsg == false) {
        recu = Serial.read();

        if (recoitEnProgres == true) {
            if(recu != charFin) {
                message[i] = recu;
                i++;
                if (i >= n) {
                    i = n - 1;
                }
            }
            else {
                message[i] = '\0';
                recoitEnProgres = false;
                i = 0;
                nouveauMsg = true;
            }
        }
        else if (recu == charDebut) {
            recoitEnProgres = true;
        }
    }
}


//Sépare le message en trois parties
//      - onOff : indique d'allumer ou éteindre la pompe
//      - bpm : indique la fréquence
//      - pourcentage : indique le pourcentage de pression
void separerMsg() {
    char * strtokIndex;

    strtokIndex = strtok(message,",");
    strcpy(onOff, strtokIndex);        

    strtokIndex = strtok(NULL,",");
    bpm = atoi(strtokIndex);           

    strtokIndex = strtok(NULL,",");
    pourcentage = atoi(strtokIndex);   
}


//Allume et éteint la pompe à différentes fréquences et intensités 
//ou éteindre la pompe en attente d'un signal pour la mettre en marche.
void allumerPompe() {
    if (onOff[0] == 'a') {
        digitalWrite(pompe, LOW);                      
    }

    else if (onOff[0] == 'd') {
        pression = map(pourcentage, 0, 100, 178, 240); 
        temps = 60000/(2*bpm);                       
        analogWrite(pompe, pression);             
        delay(temps);
        digitalWrite(pompe, LOW);                     
        delay(temps);
    }
}
